/*
 * Created on 23-Apr-04
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package adder;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
/**
 * @author searle
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AdderEJBClient {

	public static void main(String[] args) {
		int javaResult = AdderJava.add(1,2);
		System.out.println("AdderEJBClient: Java adder(1,2) = "+javaResult ); 
		AdderEJBClient ejbClient = new AdderEJBClient();
		ejbClient.jndiAdderTests();
	}

	public int add(int i, int j){
		int jndiResult = -1;
		try {
			jndiResult = jndiAdder(i,j,"adder/AdditionHome");
			System.out.println("AdderEJBClient: add("+i+","+j+") = "+jndiResult); 
		}catch(Exception e){
			System.out.println("AdderEJBClient: add Exception="+e.getMessage() );
		}
		return jndiResult;
	}
	
	public int jndiAdder(int i, int j, String jndiName) throws Exception {
		int result = -1;
		AdditionHome home = getHome(jndiName);
		Addition Addition = home.create();
		result = Addition.add(i,j);
		return result;
	}

	public AdditionHome getHome(String jndiName) throws Exception {
		try {
			//##############################################################
			Hashtable env = new Hashtable();
			//String NAME_SYNTAX = "com.ibm.websphere.naming.name.syntax";
			//String NAME_SYNTAX_JNDI = "jndi";
			//env.put(NAME_SYNTAX, NAME_SYNTAX_JNDI);
			env.put(Context.INITIAL_CONTEXT_FACTORY, "com.ibm.websphere.naming.WsnInitialContextFactory");
			//env.put(Context.PROVIDER_URL, "corbaloc:iiop:localhost:2809");
			//env.put(Context.PROVIDER_URL, "iiop://localhost");
			InitialContext initialContext = new InitialContext(env);
			
			java.lang.Object objHome = initialContext.lookup(jndiName);
			AdditionHome home = (AdditionHome) 
				(javax.rmi.PortableRemoteObject.narrow(objHome, AdditionHome.class));
			 return home;
		} catch (NamingException ex) {
			System.out.println("AdderEJBClient: JNDIlookup NamingException="+ex.getMessage() );
			throw ex;
		} catch (Exception ex) {
			System.out.println("AdderEJBClient: JNDIlookup Exception="+ex.getMessage() );
			throw ex;
		}
	}
	
	public void jndiAdderTests() {
		int jndiResult;
		String jndiName;
		try {
			jndiName = "adder/AdditionHome";
			jndiResult = jndiAdder(3,4,jndiName);
			System.out.println("AdderEJBClient: JNDI adder(3,4)= "+jndiResult+" (EJBsessionbean = "+jndiName+")"); 
		}catch(Exception e){}
		try {
			jndiName = "AdditionHome";
			jndiResult = jndiAdder(5,6,jndiName);
			System.out.println("AdderEJBClient: JNDI adder(5,6)= "+jndiResult+" (EJBsessionbean = "+jndiName+")"); 
		}catch(Exception e){}
		try {
			jndiName = "java:comp/env/ejb/AdditionHome";
			jndiResult = jndiAdder(7,8,jndiName);
			System.out.println("AdderEJBClient: JNDI adder(7,8)= "+jndiResult+" (EJBsessionbean = "+jndiName+")"); 
		}catch(Exception e){}
		try {
			jndiName = "AdditionHome_WASjndi";
			jndiResult = jndiAdder(9,10,jndiName);
			System.out.println("AdderEJBClient: JNDI adder(9,10)= "+jndiResult+" (EJBsessionbean = "+jndiName+")"); 
		}catch(Exception e){}
		System.out.println("AdderEJBClient: jndiAdderTests DONE."); 
	}
}
